/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni 7B ... znaky, switch, generovani pseudonahodnych cisel
*/

#include<iostream>
#include<ctime>
using namespace std;

/* SWITCH bez prikazu break a bez vetve default */
void vypis0(int a)
{
	switch (a)
	{
	case 1:
		cout << "jedna ";
	case 3:
		cout << "tri ";
	case 2:
		cout << "dva ";
	}
	cout << '\n';
}


/* SWITCH s vetvi "default" a s prikazy break  */
void vypis1(int a)
{
	switch (a)
	{
	case 1:
		cout << "jedna";
		break;
	case 3:
		cout << "tri";
		break;
	case 2:
		cout << "dva";
		break;
	default:
		cout << "neco jineho";
		break;
	}
	cout << '\n';
}


/* SWITCH s vetvi "default" a s prikazy break ... slozitejsi  */
void vypis(int a)
{
	switch (a)
	{
	case 6:
		cout << "sest nebo ";
	case 7:
		cout << "sedm";
		break;
	case 4:
	case 5:
		cout << "ctyri nebo pet";
		break;
	case 1:
		cout << "jedna";
		break;
	case 3:
		cout << "tri";
		break;
	case 2:
		cout << "dva";
		break;
	default:
		cout << "neco jineho";
		break;
	}
	cout << '\n';
}


int objemy0()
{
	double pi = 3.14;
	double V, S;
	
	cout << "kalkulacka\n";
	cout << "pro objem a povrch koule stiskni k\n";
	cout << "pro objem a povrch valce stiskni v\n";
	cout <<	"pro objem a povrch jehlanu stiskni j\n";
	cout << "pro ukonceni stiskni z";
	char znak;
	cin >> znak;
	// ukazka switch 
	switch (znak)
	{
	case 'a':
		break;
	}

	if (znak=='k')
	{
		cout << "****** Objem a povrch koule ******" << endl;
		double r;
		cout << "Zadej polomer koule: ";
		cin >> r;
		V = 4.0 / 3 * pi * pow(r, 3);
		S = 4 * pi * r * r;
		cout << "objem koule je " << V << ", jeji povrch je " << S << endl;
	}
	else if (znak=='v')
	{
		cout << "****** Objem a povrch valce ******" << endl;
		double r, v;
		cout << "Zadej polomer podstavy valce: ";
		cin >> r;
		cout << "Zadej vysku valce: ";
		cin >> v;
		V = pi * pow(r, 2) * v;
		S = 2 * pi * r * (r + v);
		cout << "objem jehlanu je " << V << ", jeho povrch je " << S << endl;
	}
	else if (znak == 'j')
	{
		cout << "****** Objem a povrch jehlanu ******" << endl;
		double a, v;
		cout << "Zadej delku strany podstavy jehlanu: ";
		cin >> a;
		cout << "Zadej vysku jehlanu: ";
		cin >> v;
		V = 1.0 / 3 * v * pow(a, 2);
		S = a * (a + sqrt(4 * pow(v, 2) + pow(a, 2)));
		cout << "objem jehlanu je " << V << ", jeho povrch je " << S << endl;
	}

	return 0;
}

void myslimsi()
{
	int hadane, cislo = rand() % 100 + 1;
	do
	{
		cout << "zadej cislo od 1 do 100:";
		cin >> hadane;
		if (!cin)
		{
			cin.clear();
			cin.ignore(256, '\n');
			continue;
		}
		if (hadane > cislo)
			cout << "zkus mensi cislo. ";
		else if (hadane < cislo)
			cout << "zkus vetsi cislo. ";

	} while (cislo != hadane);

	cout << "trefa!" << endl;
}

int main()
{
	{ // datovy typ char

		// deklarace promenne a jeji inicializace
		char a = 'a';
		char b = 97;      // kod znaku v ASCII tabulce (dekadicky)
		char c = '\141';  // kod znaku v ASCII tabulce (oktalove)
		char d = '\x61';  // kod znaku v ASCII tabulce (hexadecimalne)

		// operace nad znaky
		a += 4;
		a += 'a';
		if (a > 150)
			;
		if (a >= 'a')
			;
		a = 'q';
		a = '\'';

		// vypis znaku na konzoli:
		cout << a << ' ' << b << '\t' << c << d << '\n';

		// pretypovani na int, vypis ASCII kodu znaku:
		int x = a;
		cout << x << (int)a << a << b << c << d << '\n';

		// nacitani znaku z klavesnice ... s vynechanim bilych znaku
		cout << "zadej alespon 8 znaku (i mezery): ";
		cin >> a;
		cin >> b;
		cin >> c;
		cin >> d;
		cout << a << b << c << d << '\n';

		// nacitani znaku z klavesnice ...bez vynechani bilych znaku
		a = getchar();
		b = getchar();
		c = getchar();
		d = getchar();
		cout << a << b << c << d << '\n';

		putchar(a);
		putchar('a');

		// pouziti funkci z knihovny cctype:
		if (isalpha(a))
			cout << (char)toupper(a) << endl;
	}

	// ukazky na switch:
	for (int i = 0; i < 5; i++)
	{
		cout << i << ": ";
		vypis0(i);
	}

	for (int i = 0; i < 5; i++)
	{
		cout << i << ": ";
		vypis1(i);
	}

	for (int i = 0; i < 10; i++)
	{
		cout << i << ": ";
		vypis(i);
	}

	objemy0();

	// ukazky generovani pseudonahodnych cisel:
	{
		srand(15554);      // pevne dany pocatecni 'seed' generatoru
		// srand(time(0)); // pokazde jiny 'seed' generatoru

		int cislo = rand();
		cislo = rand() % 10;
		cout << "vypisuji nahodna cisla: ";
		for (int i = 1; i < 5; i++)
			cout << rand() % 10 << '\n';

		myslimsi();
	}

	return 0;
}